%option noyywrap

nl \r|\n|\r\n
ws [ \t]
id [A-Za-z_][A-Za-z0-9_]*
integer ([1-9][0-9]*|0)
double (([0-9]+\.[0-9]*)|([0-9]*\.[0-9]+))(e|E('+'|'-')?[0-9]+)?
COMMENT "/*"([^*]*|"*"+[^*/])"*"+\/

%%

"(" {printf("RO ");}
")" {printf("RC ");}
"{" {printf("BO ");}
"}" {printf("BC ");}
"=" {printf("EQ ");}
"+" {printf("PLUS ");}
"-" {printf("MINUS ");}
"*" {printf("STAR ");}
"/" {printf("DIV ");}
"<" {printf("MIN ");}
">" {printf("MAJ ");}
"<=" {printf("MIN_EQ ");}
"=<" {printf("EQ_MIN ");}
">=" {printf("MAJ_EQ ");}
"=>" {printf("EQ_MAJ ");}
"&" {printf("AND ");}
"|" {printf("OR ");}
"!" {printf("NOT ");}

"[" {printf("SO ");}
"]" {printf("SC ");}

"int" {printf("INT_TYPE ");}
"double" {printf("DOUBLE_TYPE ");}

print {printf("PRINT ");}
if {printf("IF ");}
while {printf("WHILE ");}
else {printf("ELSE ");}
; {printf("S ");}
, {printf("C ");}

{id} {printf("ID:%s ", yytext);}
{integer} {printf("INT:%s ",yytext);}
{double} {printf("DOUBLE:%s ",yytext);}

{COMMENT} {;}

{ws}|{nl} {;}

. {printf("SCANNER ERROR: %s\n", yytext);}


%%
int main(int argc, char const *argv[]) {
  yyin = fopen(argv[1], "r");
  yylex();
  fclose(yyin);
  return 0;
}
